<?php
/****************************************************************
 * (C) 2004, Roberto A. Foglietta <me@roberto.foglietta.name>
 *           Rilasciato sotto licenza GPL
 *
 *  Il supporto e la manutenzione di questo software NON  
 * garantito in quanto il presente viene ceduto cos com'.
 *  Se trovate bachi o avete necessit di personalizzarlo
 * sentitevi liberi di contattarmi.
 *
 * Ver.: 0.1 del 1994 - in collaborazione con l'Agenzia delle
 *                      Idee di Certosa di Rivarolo (GE)
 *
 * Ver.: 0.2 del 2004 - Completamente riscritta in PHP4
 *                      codice HTML testato su Firefox 0.9
 *
 ***************************************************************
 *
 * 2004-10-16: scrittura prima stesura con la gestione delle
 * Ver.:0.2.1  quattro direzioni e la mappa iniziale.
 *             Gestione dei commenti e rotazione delle freccie
 *             Creata la prima parte di "Bronzolo Virtuale"
 *
 * 2004-10-23: Aggiunte le freccie a 45 e disegnate le freccie
 * Ver.:0.2.2  su un piano in prospettiva. Bugfix della griglia
 *             sulla mappa. Continuata la creazione del paesaggio
 *             virtuale e ricostruito con anche le direzioni 
 *             aggiunte. Ridotto la compressione delle JPEG a 67%
 *
 * 2005-04-01: bugfix dell'allineamento delle freccie
 * Ver.:0.2.3
 *
 * 2006-01-23: modificato il sistema di echo (bugfix: rendering)
 * Ver.:0.2.4  le direzioni sono create da una funzione
 *             estensione dei commenti configurabile e comp.winz
 *
 ***************************************************************/

function create_pnt_list($path) {
	if(!is_dir($path)) 
		return "";

	#RAF 2003-03-15: generalizzazione
	$handle=opendir($path);
	while ($file = readdir($handle)) {
		/*if ( !($file=="." or $file=="..")
		and  !ereg("^\.",$file)
		and  !ereg("^none_",$file)
		and  !ereg("\.descr$",$file)
		and  !ereg("~$", $file) ) {*/
		if( ereg("^av|^dt|^sx|^dx|^o\.htm$|jpg$", $file)) {
			//echo "<br>preso: $file";
			$list .= "$file ";
		} else {
			//echo "<br>scartato: $file";
		}
	}
	closedir($handle);
	$list = explode(" ", $list);
	sort($list);
	
	//echo "<p>list: $list[0]</p>";
	return $list;
}

function read_file_rows($file) {
	$fd = fopen($file,"r");
	if(!$fd) return "";
	
	$i = -1;
	do {
		$i++;
		$str[$i]  = fgets($fd,20);
		//echo "<br>str $i: '$str[$i]'";
	} while ($str[$i] != NULL);
	
	return $str;
}

function link_in_rows($dir, $row) {
	$str="";
	for($k = 0; $k < sizeof($row); $k++) {
		//echo "<br>dir: $dir -- '$row[$k]'";
		if(eregi("^$dir: ", $row[$k])) {
			$str = eregi_replace("^$dir: (.*)", "\\1", $row[$k]);
			//echo " == TROVATO! ($str)";
			break;
		}
	}
	return trim($str);
}

function include_file($filename) {
        $string = "";
        if(is_file($filename)) {
                if(ob_start()) {
                        include ($filename);
                        $string = ob_get_contents();
                        ob_end_clean();
                }
        }
        return $string;
}


function create_dir_table($pnt, $dir, $list, $map){
	global $descr_file_ext, $esiste_database;
	# RAF, 17-10-2004: visualizza il codice HTML della matrice
	$ret = "
<table border='0' cellpadding='0' cellspacing='0' width='200' height='480'>
	<tr height='100%' valign='bottom'>";

	if($esiste_database != TRUE) {
		$ret.=  "
		<td align='left'>
			<b>Cod. zona: </b><font face='courier' color='red'>$pnt($dir)</font>";
		if(is_file("$pnt/$dir.$descr_file_ext")) {
			$ret.=  "
			<br><b>Commento di zona:</b>
			<hr shadow='0'>";
			$ret.= include_file("$pnt/$dir.$descr_file_ext");
		}
		$ret.= "
			<br><hr shadow='0'><br>
		</td>
	</tr>
	<tr valign='bottom'><td align='center'>";	
	} else {
		/* SUMA www.villahanbury.com DB USAGE */
	}

	//RAF 2006-01-23: spostata la creazione della stella delle freccie in una funzione tutta sua
	$ret.= get_rowstar($pnt, $dir, $list, $map);
	$ret.= "
		</td>
	</tr>
</table>";
	return $ret;
}

function get_rowstar($pnt, $dir, $list, $map) {
	$freccie = array("asx", "av", "adx", 
			 "sx",  "o",  "dx", 
			 "dsx", "dt", "ddx");
				 
	for($j = 0; $j < sizeof($list); $j++) {
		//echo "<p>list($j): $list[$j],";
		$cnt[$j] = eregi_replace("(.*)\.jpg","\\1", $list[$j]);
		if($cnt[$j] == $dir)
			$cnt[$j] = "";
		//echo "cnt($j): $cnt[$j], list($j): $list[$j]</p>";
	}
	
	if(is_file("$pnt/$dir.txt")) {
		$row = read_file_rows("$pnt/$dir.txt");
	}
	
	# RAF, 17-10-2004: inizializza le celle della matrice 3x3 delle freccie
	for($i = 0; $i < 3; $i++) 
		for($j = 0; $j < 3; $j++)
			$td[$i*3+$j]="<img src='freccie/nul.png'>";
		
	// Matrice di compensazione di una rotazione di +45		 	
	//             0  1  2  3  4  5  6  7  8 
	$quart = array(3, 0, 1, 6, 4, 2, 7, 8, 5);
	
	# RAF, 17-10-2004: si occupa della rotazione direzionale della matrice
	for($i = 0; $i < 3; $i++) {
		for($j = 0; $j < 3; $j++) {
			$ij=$i*3+$j;
			
			switch($dir) {
				case "sx":  
					$ji = (2-$i)+$j*3;	//Compenso la rotazione di -90
					break;
				case "dx":  
					$ji = $i+(2-$j)*3;	//Compenso la rotazione di +90
					break;
				case "dt":  
					$ji = (2-$i)*3+(2-$j);	//Compenso la rotazione di 180
					break;
				case "adx": 
					$ji = $quart[$ij];	//Compenso la rotazione di +45
					break;	
				case "asx": 
					$ji  = (2-$i)+$j*3;	//Compenso la rotazione di -90
					$ji = $quart[$ji];	//Compenso la rotazione di +45
					break;	
				case "dsx": 
					$ji = (2-$i)*3+(2-$j);	//Compenso la rotazione di 180
					$ji = $quart[$ji];	//Compenso la rotazione di +45
					break;	
				case "ddx": 
					$ji = $i+(2-$j)*3;	//Compenso la rotazione di +90
					$ji = $quart[$ji];	//Compenso la rotazione di +45
					break;		
				default:   $ji=$ij;
					break;
			}
						 
			for($k = 0; $k < sizeof($list); $k++) {
				if($cnt[$k] == $freccie[$ij]) {
					$td[$ji]= "<a href='index.php?pnt=$pnt-$freccie[$ij]'><img src='freccie/$freccie[$ji].png' border='0'></a>";
					break;
				}
			}
			
			$link = link_in_rows($freccie[$ij],$row);
			if($link == "none") $td[$ij]= "";
			else if($link != "") {
				$td[$ij]= "<a href='index.php?pnt=$link'><img src='freccie/$freccie[$ij].png' border='0'></a>";
			}
		}
	}

	$ret = "\n<table border='0' cellpadding='0' cellspacing='0' background='freccie/all.png' width='200' height='100'>";
	$height = array(25,25,50);
	for($i = 0; $i < 3; $i++) {
		$ret .= "\n<tr height='$height[$i]'>";
		$ret .= "\n<td width='25'><img src='freccie/nul.png' width='25' height='$height[$i]'></td>";
		for($j = 0; $j < 3; $j++) {
			if($j == 1 && $i == 1) {
				$ret .= "\n<td width='50'><a href='$map'><img src='freccie/o.png' width='50' height='$height[$i]' border='0'></a></td>";
			} else {
				$ij=$i*3+$j;
				$ret .= "\n<td width='50' height='$height[$i]'>$td[$ij]</td>";
			}
		}
		$ret .= "\n<td width='25'><img src='freccie/nul.png' width='25' height='$height[$i]'></td>";
		$ret .= "\n</tr>";
	}
	$ret .= "\n</table>";
	return $ret;
}


# RAF, 17-10-2004: ATTENZIONE, il primo parametro deve essere passato come puntatore
function get_start($dir, $list) {
	if($dir == "") {
		for($j = 0; $j < sizeof($list); $j++) {
			//echo "<H2>list $j: $list[$j]</H2>";
			if(eregi("^o\.",$list[$j])) {
				//echo "<H2>start: $list[$j]</H2>";
				$dir="o";
				break;
			}
		}
		if($j == sizeof($list)) {
			for($j = 0; $j < sizeof($list); $j++) {
				if(eregi("av\.",$list[$j])) {
					$dir="av";
					break;
				}
			}
		}
	} else {
		for($j = 0; $j < sizeof($list); $j++) {
			if(eregi("^$dir\.",$list[$j])) {
				break;
			}
		}
	}
	$start = $list[$j];
	$list[$j] = "";
	return $start;
}
	
//=====================================================================CONFIGURAZIONE	
$punto_di_partenza="Q11";
$esiste_database=FALSE;
$descr_file_ext="descr";
	

	
$pntdir=$_GET['pnt'];
if($pntdir == "") {
	$pnt = $punto_di_partenza;
	$dir="";
} else {
	$pnt=eregi_replace("(.*)-.*","\\1",$pntdir);
	$dir=eregi_replace("^$pnt-(.*)","\\1",$pntdir);
	if($dir == $pntdir)
		$dir="";
}
//echo "<p>pntdir: '$pntdir', pnt: '$pnt', dir: '$dir'</p>";
	
$list  = create_pnt_list($pnt);
//$start = get_start($dir, $list);
$start = get_start(&$dir, $list);
// echo $start;
$page  = create_dir_table($pnt, $dir, $list, "index.php");

if(is_file("header.htm"))
	include("header.htm");
echo  "
<center>
<table border='0'><tr>
	<td align='center' width='640' ";
if(eregi("\.htm?$",$start)) {
	echo ">";
	include("$pnt/$start");
} else {
	if(!is_file("img/sfondo.png"))
		echo "bgcolor='black'>";
	else
	 	echo "background='img/sfondo.png'>";
	echo "
		<img src='$pnt/$start' height='480' border='0'>";
}	
echo "
	</td>
	<td width='15'>&nbsp;</td>
	<td align='center'>
<!- ################################################## //-->
$page
<!- ################################################## //-->
	</td>
</tr></table>
</center>";
if(is_file("footer.htm"))
		include("footer.htm");
?>

